// cppConfigurationSetup.h
#include "idptypes.h"
#include "idpctx.h"
#include "idpurl.h"

#ifdef WIN32
#define IDPEXPORT __declspec(dllexport)
#else
#define IDPEXPORT
#endif


class IDPCIMPL_ConfigurationSetup
{
public:
	IDPCIMPL_ConfigurationSetup() {
		m_CheckSum = IDP_CHECKSUM;
	}
	~IDPCIMPL_ConfigurationSetup() {
		m_CheckSum = 0L;
	}
	long m_CheckSum;

public:
	void SetConfiguration(const STRING & Path);
	void Reconfigure(const STRING & ServerUrl, const STRING & UserName,
		const STRING & Password);
	void SetOption(const STRING & Name, const STRING & Value);
	void GetAttribute(const STRING & File, const STRING & Name, STRING & pVal);
	void SetAttribute(const STRING & File, const STRING & Name,
		const STRING & newVal);

private:
	IDP_Context m_ctx;
};
