// cppMessageFactory.h
#include "idptypes.h"
#include "idpctx.h"
#include "idpurl.h"


#ifdef WIN32
#define IDPEXPORT __declspec(dllexport)
#else
#define IDPEXPORT
#endif

class IDPCIMPL_MessageFactory
{
public:
	IDPCIMPL_MessageFactory() {
		m_Outgoing = 0;
		m_Path = _T("");
		m_CheckSum = IDP_CHECKSUM;
	}
	~IDPCIMPL_MessageFactory() {
		m_CheckSum = 0L;
	}
	long m_CheckSum;


public:
	void Open(const STRING & Path);
	IDP_HANDLE CreatePayInit();
	IDP_HANDLE VerifyPayConfirm(const STRING & Data, const STRING & Signature);
	IDP_HANDLE CreatePayComplete(const STRING & Id, const STRING & Token);
	IDP_HANDLE CreateRequest(const STRING & MsgType);

private:
	STRING m_Path;
	long m_Outgoing;
};

