// cppMessageObject.h
#include "idptypes.h"
#include "idpctx.h"
#include "idpurl.h"


#ifdef WIN32
#define IDPEXPORT __declspec(dllexport)
#else
#define IDPEXPORT
#endif


class IDPCIMPL_MessageObject
{
public:
	IDPCIMPL_MessageObject() {
		m_Outgoing = 0;
		m_CheckSum = IDP_CHECKSUM;
	}
	~IDPCIMPL_MessageObject() {
		m_CheckSum = 0L;
	}
	long m_CheckSum;

public:
	void SetAttribute(const STRING & Name, const STRING & Value);
	void Open(const STRING & Path);
	void GetAttribute(const STRING & Name, STRING & pVal);
	void GetURL(STRING & pVal);
	void Capture();
	IDP_HANDLE Execute();

	void FromString(const STRING & Message);
	STRING ToString();

public:
	IDP_Context m_ctx;
	IDP_Message m_msg;
	long m_Outgoing;
};

