TEMPLATE	= lib
CONFIG		= dll warn_off release
HEADERS		= IcctSign.h \
		  cppConfigurationSetup.h \
		  cppMessageFactory.h \
		  cppMessageObject.h \
		  idpapi.h \
		  idpctx.h \
		  idpdattr.h \
		  idperr.h \
		  idperrc.h \
		  idpexcpt.h \
		  idphttp.h \
		  idpjni.h \
		  idptypes.h \
		  idpurl.h \
		  idputil.h \
		  jConfigurationSetup.h \
		  jMessageFactory.h \
		  jMessageObject.h \
		  jni/jni.h \
		  jni/jni_md.h \
		  spliturl.h \
		  ssl/asn1.h \
		  ssl/asn1_mac.h \
		  ssl/bio.h \
		  ssl/blowfish.h \
		  ssl/bn.h \
		  ssl/buffer.h \
		  ssl/cast.h \
		  ssl/conf.h \
		  ssl/cryptall.h \
		  ssl/crypto.h \
		  ssl/des.h \
		  ssl/dh.h \
		  ssl/dsa.h \
		  ssl/e_os.h \
		  ssl/err.h \
		  ssl/evp.h \
		  ssl/hmac.h \
		  ssl/idea.h \
		  ssl/lhash.h \
		  ssl/md2.h \
		  ssl/md5.h \
		  ssl/mdc2.h \
		  ssl/objects.h \
		  ssl/pem.h \
		  ssl/pkcs7.h \
		  ssl/rand.h \
		  ssl/rc2.h \
		  ssl/rc4.h \
		  ssl/rc5.h \
		  ssl/ripemd.h \
		  ssl/rsa.h \
		  ssl/sha.h \
		  ssl/ssl.h \
		  ssl/ssl2.h \
		  ssl/ssl23.h \
		  ssl/ssl3.h \
		  ssl/stack.h \
		  ssl/tls1.h \
		  ssl/txt_db.h \
		  ssl/x509.h \
		  ssl/x509_vfy.h \
		  sxfc/sxcontainer.h \
		  sxfc/sxexcept.h \
		  sxfc/sxfcerr.h \
		  sxfc/sxfctype.h \
		  sxfc/sxfctypes.h \
		  sxfc/sxlist.h \
		  sxfc/sxmap.h \
		  sxfc/sxobject.h \
		  sxfc/sxpair.h \
		  sxfc/sxptr.h \
		  sxfc/sxsort.h \
		  sxfc/sxstack.h \
		  sxfc/sxstream.h \
		  sxfc/sxstring.h \
		  sxfc/sxtchar.h \
		  sxfc/sxvector.h \
		  uuid.h \
		  uuidP.h \
		  xml/sxstream.h \
		  xml/xmlElement.h \
		  xml/xmlElementEnum.h \
		  xml/xmlParser.h \
		  xml/xmlcore.h \
		  xml/xmlerror.h \
		  xml/xmltab.h
SOURCES		= IcctSign.cpp \
		  cConfigurationSetup.cpp \
		  cMessageFactory.cpp \
		  cMessageObject.cpp \
		  idpbase.cpp \
		  idpctx.cpp \
		  idpdattr.cpp \
		  idperr.cpp \
		  idphttp.cpp \
		  idpurl.cpp \
		  idputil.cpp \
		  jConfigurationSetup.cpp \
		  jMessageFactory.cpp \
		  jMessageObject.cpp \
		  spliturl.cpp \
		  sxfc/sxmap.cpp \
		  sxfc/sxobject.cpp \
		  sxfc/sxpair.cpp \
		  sxfc/sxstring.cpp \
		  sxfc/sxtchar.c \
		  sxfc/sxvector.cpp \
		  xml/xmlElement.cpp \
		  xml/xmlElementEnum.cpp \
		  xml/xmlParser.cpp \
		  xml/xmltab.c

INCLUDEPATH	= ./xml;./jni;./ssl;./sxfc

win32:SOURCES		+= CreateFullPath.cpp
win32:HEADERS		+= CreateFullPath.h stdafx.h
win32-msvc:SOURCES	+= ConfigurationSetup.cpp\
			   MessageFactory.cpp MessageObject.cpp stdafx.cpp idpapp.cpp
unix:SOURCES		+= guid.c uuid_time.c pack.c unpack.c

win32-msvc:HEADERS	+= idpapp.h ConfigurationSetup.h MessageFactory.h MessageObject.h\
			   stdafx.h
unix:HEADERS		+= uuid.h uuidP.h

win32:LIBS		= rpcrt4.lib urlmon.lib ws2_32.lib .\ssl\libeay32.lib\
			  .\ssl\ssleay32.lib
unix:LIBS		= ./ssl/libssl.a ./ssl/libcrypto.a -lgcc
unix:TMAKE_LFLAGS += -fPIC

win32:TMAKE_CXXFLAGS += -GX -DUNICODE -DXML_WCS -DWIN32
win32:TMAKE_CFLAGS   += -DUNICODE -DXML_WCS -DWIN32
unix:TMAKE_CFLAGS    += -DUNIX -DHAVE_UNISTD_H -DHAVE_STDLIB_H
unix:TMAKE_CXXFLAGS  += -DUNIX
linux:TMAKE_CXXFLAGS	+= -DPTRDIFF_T_DEFINED
linux:TMAKE_CFLAGS	+= -DPTRDIFF_T_DEFINED
aix-xlc:TMAKE_CFLAGS	+= -DB_ENDIAN -qcpluscmt
aix-xlc:TMAKE_CXXFLAGS	+= -DB_ENDIAN -qnotempinc
solaris-g++:TMAKE_CFLAGS += -DB_ENDIAN
solaris-g++:TMAKE_CXXFLAGS += -DB_ENDIAN
solaris-g++:LIBS += -lsocket
hpux:TMAKE_CXXFLAGS += -DB_ENDIAN
hpux:TMAKE_CFLAGS += -DB_ENDIAN
debug:TMAKE_CFLAGS	+= -D_DEBUG
debug:TMAKE_CXXFLAGS	+= -D_DEBUG


win32:RC_FILE		= idpapp.rc
win32:DEF_FILE		= idpapp.def

unix:CLEAN_FILES	= ./out/libidpapp*
win32:CLEAN_FILES	= ./out/idpapp.dll

DESTDIR		= ./out
TARGET		= idpapp
