// idperr.h

#ifndef __IDPERR_H__
#define __IDPERR_H__

#include "idptypes.h"
#include "idperrc.h"

//	IDP_Exception class
//	-------------------

struct IDP_Exception
{
	HRESULT hr;
	STRING ErrorString;
	STRING SourceFile;
	long LineNumber;

	// constructors
	IDP_Exception(HRESULT newHr, const STRING & newErrorString, LPCSTR newSourceFile,
		long newLineNumber);
};

#define IDPTHROW1(_hr) { IDP_Exception _e(_hr, _T(""), __FILE__, __LINE__); throw _e; }
#define IDPTHROW2(_hr, _Desc) { IDP_Exception _e(_hr, _Desc, __FILE__, __LINE__); throw _e; }

//	IDP_TraceLog class
//	------------------

struct IDP_TraceLog
{
	static void Write(LPCSTR Module, long LineNumber, HRESULT hr, 
		const STRING & Action, const STRING & Text);
};

#define IDPTRACE(hr, Action, Text) IDP_TraceLog::Write(__FILE__, __LINE__, hr, Action, Text)

#endif
