// idpjni.h: #defines for JNI

#define IDPJNI_GET_HANDLE(p, T, strFunc) {\
			jfieldID fid;\
			jclass cls = env->GetObjectClass(obj);\
			fid = env->GetFieldID(cls, "m_Handle", "I");\
			p = NULL;\
			if (fid) {\
				p = (T*)env->GetIntField(obj, fid);\
				if(!!p) {\
					if(((T*)p)->m_CheckSum != IDP_CHECKSUM) {\
						p = NULL;\
					}\
				}\
			}\
		}\
	
#define IDPJNI_GET_AND_CHECK_HANDLE1(p, T, strFunc) {\
			jfieldID fid;\
			jclass cls = env->GetObjectClass(obj);\
			fid = env->GetFieldID(cls, "m_Handle", "I");\
			if (fid == 0)\
			{\
				IDPJNI_THROW1(strFunc ": member m_Handle not found", IDP_E_UNEXPECTED);\
				return;\
			}\
			p = (T*)env->GetIntField(obj, fid);\
			if(!p) {\
				IDPJNI_THROW1(strFunc ": Invalid Handle", IDP_E_UNEXPECTED);\
				return;\
			}\
			if(((T*)p)->m_CheckSum != IDP_CHECKSUM) {\
				IDPJNI_THROW1(strFunc ": Invalid Handle", IDP_E_UNEXPECTED);\
				return;\
			}\
		}

#define IDPJNI_GET_AND_CHECK_HANDLE2(p, T, strFunc, ret) {\
			jfieldID fid;\
			jclass cls = env->GetObjectClass(obj);\
			fid = env->GetFieldID(cls, "m_Handle", "I");\
			if (fid == 0)\
			{\
				IDPJNI_THROW2(strFunc ": member m_Handle not found", IDP_E_UNEXPECTED, ret);\
				return ret;\
			}\
			p = (T*)env->GetIntField(obj, fid);\
			if(!p) {\
				IDPJNI_THROW2(strFunc ": Invalid Handle", IDP_E_UNEXPECTED, ret);\
				return ret;\
			}\
			if(((T*)p)->m_CheckSum != IDP_CHECKSUM) {\
				IDPJNI_THROW2(strFunc ": Invalid Handle", IDP_E_UNEXPECTED, ret);\
				return ret;\
			}\
		}


#define IDPJNI_THROW1(msg, hr) {\
		jclass IDPExc = env->FindClass("soplex/saferpay/IDPException");\
		if(!IDPExc)\
		{\
			env->FatalError("Class soplex/saferpay/IDPException not found");\
			return;\
		}\
		jmethodID nConstructor = env->GetMethodID(IDPExc, "<init>", "()V");\
		jmethodID nPutHR = env->GetMethodID(IDPExc, "putHR", "(I)V");\
		jmethodID nPutErrorMessage = env->GetMethodID(IDPExc, "putErrorMessage",\
			"(Ljava/lang/String;)V");\
		if(!nConstructor || !nPutHR || !nPutErrorMessage)\
		{\
			env->FatalError("Incompatible class soplex/saferpay/IDPException");\
			return;\
		}\
		jobject excObj = env->NewObject(IDPExc, nConstructor);\
		env->CallVoidMethod(excObj, nPutHR, hr);\
		env->CallVoidMethod(excObj, nPutErrorMessage, env->NewStringUTF(msg));\
		env->Throw((jthrowable)excObj);\
		}


#define IDPJNI_THROW2(msg, hr, ret) {\
		jclass IDPExc = env->FindClass("soplex/saferpay/IDPException");\
		if(!IDPExc)\
		{\
			env->FatalError("Class soplex/saferpay/IDPException not found");\
			return ret;\
		}\
		jmethodID nConstructor = env->GetMethodID(IDPExc, "<init>", "()V");\
		jmethodID nPutHR = env->GetMethodID(IDPExc, "putHR", "(I)V");\
		jmethodID nPutErrorMessage = env->GetMethodID(IDPExc, "putErrorMessage",\
			"(Ljava/lang/String;)V");\
		if(!nConstructor || !nPutHR || !nPutErrorMessage)\
		{\
			env->FatalError("Incompatible class soplex/saferpay/IDPException");\
			return ret;\
		}\
		jobject excObj = env->NewObject(IDPExc, nConstructor);\
		env->CallVoidMethod(excObj, nPutHR, hr);\
		env->CallVoidMethod(excObj, nPutErrorMessage, env->NewStringUTF(msg));\
		env->Throw((jthrowable)excObj);\
		}

#ifdef UNICODE
#define _NewString(x) NewString((x).c_str(), (x).size())
#else
#define _NewString(x) NewStringUTF((x).c_str())
#endif




