// idptypes.h

#ifndef __IDPTYPES_H__
#define __IDPTYPES_H__

#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#if (defined(UNICODE) && (!defined(XML_WCS)))
#define XML_WCS
#endif

#ifdef WIN32
#pragma warning(disable : 4786)
#endif

typedef unsigned char UCHAR;
typedef unsigned long ULONG;
typedef long HRESULT;


typedef char CHAR;
typedef CHAR * LPSTR;
typedef const CHAR * LPCSTR;

typedef wchar_t WCHAR;
typedef WCHAR * LPWSTR;
typedef const WCHAR * LPCWSTR;

#ifndef _T
#ifdef UNICODE
#define _T(x)     L ## x
#else
#define _T(x)	x
#endif
#endif

#ifdef WIN32
#define IDPCALL __stdcall
#else
#define IDPCALL
#endif

#include "sxfc/sxstring.h"
#include "sxfc/sxstream.h"

typedef SxStringStream STRINGSTREAM;
typedef SxString STRING;
typedef SxStringStream OUTSTREAM;
typedef SxStringStream INSTREAM;

typedef TCHAR * LPTSTR;
typedef const TCHAR * LPCTSTR;


#if defined(UNICODE) || defined(XML_WCS)

// UNICODE version
#define tcslen				wcslen
#define tcscpy				wcscpy
#define tprintf				wprintf
#define topen				_wfopen
#define tsprintf			swprintf
#define tcschr				wcschr
#define tcscmp				wcscmp
#define tcsncmp				wcsncmp
#define	tcscat				wcscat
#define tcstod				wcstod
#define ttoi				_wtoi


#define tcout wcout

#else

// ANSI build

#define tcslen				strlen
#define tcscpy				strcpy
#define tprintf				printf
#define topen				fopen
#define tsprintf			sprintf
#define tcschr				strchr
#define tcscmp				strcmp
#define tcscat				strcat
#define tcstod				strtod
#define tcsncmp				strncmp
#define ttoi				atoi


#define tcout cout

#endif


#endif
