// idputil.cpp

#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include "idpctx.h"
#include "idperr.h"
#include "idputil.h"

void IDP_Context::SlToBackSl(STRING & s)
{
	STRING::iterator i;

	for(i = s.begin(); i != s.end(); ++i)
	{
		if(* i == '/')
			* i = '\\';
	}
}


STRING IDP_Context::Encode(const STRING & a)
{
	STRINGSTREAM s;
	STRING::const_iterator i;
	for(i = a.begin(); i != a.end(); ++i)
	{
		UCHAR uc = (UCHAR) * i;
		if(isalnum(uc))
			s << TCHAR(uc);
		else
		{
			TCHAR ti[9];

			tsprintf(ti, _T("%02x"), uc);
			s << _T("%") << ti;
		}
	}

	STRING r = s.str();
	return r;
}

STRING IDP_Context::BufferToHex(UCHAR * pData, ULONG cbData)
{
	TCHAR tmp[123];	
	STRING r;

	for(ULONG i = 0; i < cbData; ++i)
	{
		tsprintf(tmp, _T("%02x"), pData[i]);
		r += tmp;
	}
	return r;
}

HRESULT IDP_Context::HexToBuffer(STRING r, UCHAR * data, ULONG * size)
{
	UCHAR t[2];
	STRING::iterator i; ULONG k = 0;
	for(i = r.begin(); i != r.end(); ++i, ++k)
	{
		if((k / 2) >= * size)
			return IDP_E_BUFFER_SIZE;

		if(('0' <= * i) && (* i <= '9'))
			t[0] = UCHAR(* i - '0');
		else if(('A' <= * i) && (* i <= 'F'))
			t[0] = UCHAR(* i - 'A' + 10);
		else if(('a' <= * i) && (* i <= 'f'))
			t[0] = UCHAR(* i - 'a' + 10);
		else
			return IDP_E_FAIL;

		if(k % 2)
		{
			data[k / 2] = t[1] * 16 + t[0];
		}
		else
		{
			t[1] = t[0];
		}
	}

	* size = k / 2;

	return IDP_S_OK;
}

STRING mbstoSTRING(const char *psz)
{
	STRING s(_T(""));

#ifdef UNICODE
	wchar_t *pszw = NULL;
	long l = strlen(psz);
	if(psz)
	{
		if(!(pszw = (wchar_t*)malloc((l+1)*sizeof(wchar_t))))
			IDPTHROW1(IDP_E_OUT_OF_MEMORY);
		mbstowcs(pszw, psz, l+1);
		s = pszw;
		free(pszw);
	}
#else
	if(psz)
	{
		s = psz;
	}
#endif
	return s;
}


void WCSToMBS(char * tar, const WCHAR * src, unsigned long size)
{
	wcstombs(tar, src, size);
}


STRING GetTimeDate(double Shift)
{
	time_t Time = time(0);
	Time += (time_t) Shift;
	tm *pTm = gmtime(&Time);
	
	TCHAR buf[256];
	tsprintf(buf, _T("%04d%02d%02d %02d:%02d:%02d\0"), 
		pTm->tm_year + 1900, pTm->tm_mon + 1, pTm->tm_mday, pTm->tm_hour, pTm->tm_min, pTm->tm_sec);

	return buf;

}
