package soplex.saferpay;

public class ConfigurationSetup implements IConfigurationSetup
{
	private synchronized native void nConstruct() throws IDPException;
	private synchronized native void nDestruct();
	
	public synchronized native void SetConfiguration(String Path)
		throws IDPException;
	
	public synchronized native void Reconfigure(String ServerUrl,
												String UserName,
											String Password) throws IDPException;
	
	public synchronized native void SetOption(String Name, String Value)
		throws IDPException;
	
	public synchronized native String GetAttribute(String File, String Name)
		throws IDPException;
	
	public synchronized native void SetAttribute(String File, String Name, String newVal)
		throws IDPException;
	
	
static
{
	try
	{
		System.loadLibrary("idpapp");
	}
	catch(UnsatisfiedLinkError e)
	{
		System.out.println("failed to load library \"idpapp\":\n" + e);
	}
}

	public ConfigurationSetup() throws IDPException
	{
		m_Handle = 0;
		try
		{
			nConstruct();
		}
		catch(UnsatisfiedLinkError e)
		{
			IDPException ie =
				new IDPException("failed to construct ConfigurationSetup:\n" + e);
			throw ie;
		}
		if(m_Handle == 0)
		{
			IDPException ie =
				new IDPException("failed to construct ConfigurationSetup:\n");
			throw ie;
		}
	}
	protected void finalize() throws Throwable
	{
		nDestruct();
	}	
	
	private int m_Handle;
}