package soplex.saferpay;

public class MessageFactory implements IMessageFactory
{
	private synchronized native void nConstruct() throws IDPException;
	private synchronized native void nDestruct();
	private native int nCreatePayInit() throws IDPException;
	private native int nVerifyPayConfirm(String Data, String Signature)
		throws IDPException;
	private native int nCreatePayComplete(String Id, String Token)
		throws IDPException;
	private native int nCreateRequest(String MsgType)
		throws IDPException;
	
	public synchronized native void Open(String Path) throws IDPException;
static
{
	try
	{
		System.loadLibrary("idpapp");
	}
	catch(UnsatisfiedLinkError e)
	{
		System.out.println("failed to load library \"idpapp\":\n" + e);
	}
}
	public MessageFactory() throws IDPException
	{
		m_Handle = 0;
		try
		{
			nConstruct();
		}
		catch(UnsatisfiedLinkError e)
		{
			IDPException ie =
				new IDPException("failed to construct MessageFactory:\n" + e);
			throw ie;
		}
		if(m_Handle == 0)
		{
			IDPException ie =
				new IDPException("failed to construct MessageFactory:\n");
			throw ie;
		}
	}
	protected void finalize() throws Throwable
	{
		nDestruct();
	}	

	public synchronized MessageObject CreatePayInit() throws IDPException
	{
		MessageObject mo = new MessageObject(nCreatePayInit());
		return mo;
	}	
	public synchronized MessageObject VerifyPayConfirm(String Data, String Signature)
		throws IDPException
	{
		MessageObject mo;
		mo = new MessageObject(nVerifyPayConfirm(Data, Signature));
		return mo;
	}
	public synchronized MessageObject CreatePayComplete(String Id, String Token)
		throws IDPException
	{
		MessageObject mo = new MessageObject(nCreatePayComplete(Id, Token));
		return mo;
	}	
	public synchronized MessageObject CreateRequest(String MsgType)
		throws IDPException
	{
		MessageObject mo = new MessageObject(nCreateRequest(MsgType));
		return mo;
	}
	private int m_Handle;
};
