package soplex.saferpay;

public class MessageObject implements IMessageObject, ISerialize
{
	// IMessageObject interface
	// ------------------------

	public synchronized native void SetAttribute(String Name, String Value)
		throws IDPException;

	public synchronized native void Open(String Path) 
		throws IDPException;

	public synchronized native String GetAttribute(String Name)
		throws IDPException;

	public synchronized native String GetURL() 
		throws IDPException;

	public synchronized native void Capture() 
		throws IDPException;

	public synchronized MessageObject Execute()
		throws IDPException
	{
		MessageObject mo = new MessageObject(nExecute());
		return mo;
	}

	private synchronized native int nExecute() 
		throws IDPException;

	// ISerialize interface
	// --------------------

	public synchronized native void FromString(String Message) 
		throws IDPException;

	public synchronized native String ToString() 
		throws IDPException;

	// construction
	// ------------

	private synchronized native void nConstruct() 
		throws IDPException;

	private synchronized native void nDestruct();
	
	
static
{
	try
	{
		System.loadLibrary("idpapp");
	}
	catch(UnsatisfiedLinkError e)
	{
		System.out.println("failed to load library \"idpapp\":\n" + e);
	}
}

	public MessageObject() throws IDPException
	{
		m_Handle = 0;
		try
		{
			nConstruct();
		}
		catch(UnsatisfiedLinkError e)
		{
			IDPException ie =
				new IDPException("failed to construct MessageObject:\n" + e);
			throw ie;
		}
		if(m_Handle == 0)
		{
			IDPException ie =
				new IDPException("failed to construct v:\n");
			throw ie;
		}
	}
	public MessageObject(int Handle)
	{
		m_Handle = Handle;
	}
	protected void finalize() throws Throwable
	{
		nDestruct();
	}	
	
	
	private int m_Handle;
};