#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "../../idpapi.h"
#include "../../idperrc.h"

#define CHECK(msg) { if(hr != IDP_S_OK)\
	{\
		char szErr[1024];\
		long cbSize = sizeof(szErr) - 2;\
		sprintf(szErr, ": ");\
		croak(msg " (Error: 0x%08X%s)", hr,\
		IDP_GetErrorStringFromResult(hr, &cbSize, &szErr[2]) ? szErr : ""); } }
#define CHECK_CLEAN(msg, ptr) { if(hr != IDP_S_OK) { Safefree(ptr); CHECK(msg); } }

MODULE = soplex::saferpay::ConfigurationSetup		PACKAGE = soplex::saferpay::ConfigurationSetup		

void *
nConstruct()
	PREINIT:
	IDP_HANDLE result = NULL;
	CODE:
	result = CreateConfigurationSetup();
	if(!(RETVAL = result)) croak("unable to create ConfigurationSetup object;"
					" Server probably out of memory");
	OUTPUT:
	RETVAL
                                   
void
nDestruct(hCS)
	void *hCS;
	CODE:
	DestroyConfigurationSetup(hCS);

void
nSetConfiguration(hCS, pszPath)
	void *hCS;
	char *pszPath;
	PREINIT:
	HRESULT hr;
	CODE:
	hr = ConfigurationSetup_SetConfiguration(hCS, pszPath);
	CHECK("SetConfiguration failed");

void
nReconfigure(hCS, pszServerURL, pszUserName, pszPassword)
	void *hCS;
	char *pszServerURL;
	char *pszUserName;
	char *pszPassword;
	PREINIT:
	HRESULT hr;
	CODE:
	hr = ConfigurationSetup_Reconfigure(hCS, pszServerURL, pszUserName, pszPassword);
	CHECK("Reconfigure failed");
	
void
nSetAttribute(hCS, pszFile, pszName, pszNewVal)
	void *hCS;
	char *pszFile;
	char *pszName;
	char *pszNewVal;
	PREINIT:
	HRESULT hr;
	CODE:
	hr = ConfigurationSetup_SetAttribute(hCS, pszFile, pszName, pszNewVal);
	CHECK("SetAttribute failed");

SV *
nGetAttribute(hCS, pszFile, pszName)
	void *hCS;
	char *pszFile;
	char *pszName;
	PREINIT:
	HRESULT hr;
	long cbSize = 1;
	char *pszValue = NULL;
	SV *pResult;
	CODE:
	ConfigurationSetup_GetAttribute(hCS, pszFile, pszName, &cbSize, pszValue);
	New(0, pszValue, cbSize, char);
	if(!pszValue) croak("GetAtribute failed; Server out of memory");
	hr = ConfigurationSetup_GetAttribute(hCS, pszFile, pszName, &cbSize, pszValue);
	CHECK_CLEAN("GetAttribute failed", pszValue);
	pResult = sv_newmortal();
	sv_setpvn(pResult, pszValue, cbSize - 1);
	Safefree(pszValue);	
	SvREFCNT_inc(pResult);
	RETVAL = pResult;
	OUTPUT:
	RETVAL
