# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..6\n"; }
END {print "not ok 1\n" unless $loaded;}
use soplex::saferpay::ConfigurationSetup qw(ConfigurationSetup);
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

do
{
	print "Do you use a proxy server (y/n)? ";
	$useProxy = <STDIN>;
	chomp $useProxy;
} until(grep {$_ eq $useProxy} qw(y n));

if($useProxy eq "y")
{
	do
	{
		print "Enter the Name or IP address of your proxy server: ";
		$proxyAddress = <STDIN>;
		chomp $proxyAddress;
	} until($proxyAddress =~ /\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/
		or not $proxyAddress =~ /[^\w\-\.]/);
	
	do
	{
		print "Enter the number of your http proxy port (xxxx): ";
		$proxyPort = <STDIN>;
		chomp $proxyPort;
	} until($proxyPort =~ /\d{1,4}/);
	
	open FH, ">../../out/settings.xml";
	print FH "<IDP USEPROXY=\"1\" PROXYHOST=\"$proxyAddress\" PROXYPORT=\"$proxyPort\"/>\n";
	close FH;
}
else
{
	unlink "../../out/settings.xml";
}

my $CS = 0;
eval {
	$CS = soplex::saferpay::ConfigurationSetup->new();
	print "ok 2\n";
} or die "not ok 2\n", $@, "\n";

eval {
	$CS->SetConfiguration("../../out");
	print "ok 3\n";
} or die "not ok 3\n", $@, "\n";

eval {
	$CS->Reconfigure("https://www.saferpay.com/user/setup.asp", "e99867001", "XAjc3Kna");
	print "ok 4\n";
} or die "not ok 4\n", $@, "\n";

eval {
	$CS->SetAttribute("default.xml", "SOMEATTRIBUTE", "some value");
	print "ok 5\n";
} or die "not ok 5\n", $@, "\n";

eval {
	my $attr = $CS->GetAttribute("default.xml", "SOMEATTRIBUTE");
	print "ok 6\n" if($attr eq "some value") or die;
} or die "not ok 6\n", $@, "\n";


