package soplex::saferpay::MessageObject;

use strict;
use vars qw($VERSION @ISA @EXPORT @EXPORT_OK);

require Exporter;
require DynaLoader;
require AutoLoader;

@ISA = qw(Exporter DynaLoader);
# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.
@EXPORT = qw();
@EXPORT_OK = qw(MessageObject);
$VERSION = '0.01';

bootstrap soplex::saferpay::MessageObject $VERSION;

# Preloaded methods go here.

sub new
{
	my $classname = shift;
	my $self = {};
	bless($self, $classname);
	$self->_init(@_);
	
	return $self;
}

sub GetURL
{
	my $self = shift;
	return nGetURL($self->{"handle"}) if($self->{"handle"}) or die "invalid handle";
}

sub SetAttribute
{
	my $self = shift;
	nSetAttribute($self->{"handle"}, @_) if($self->{"handle"}) or die "invalid handle";
	1;
}

sub GetAttribute
{
	my $self = shift;
	return nGetAttribute($self->{"handle"}, @_) if($self->{"handle"}) or die "invalid handle";
}

sub Capture
{
	my $self = shift;
	nCapture($self->{"handle"}) if($self->{"handle"}) or die "invalid handle";
	1;
}

sub Execute
{
	my $self = shift;
	my $MO = nExecute($self->{"handle"}, @_) if($self->{"handle"}) or die "invalid handle";
	return soplex::saferpay::MessageObject->new($MO);
}

sub ToString
{
	my $self = shift;
	return nToString($self->{"handle"}) if($self->{"handle"}) or die "invalid handle";
}

sub FromString
{
	my $self = shift;
	nFromString($self->{"handle"}, @_) if($self->{"handle"}) or die "invalid handle";
	1;
}

sub Open
{
	my $self = shift;
	nOpen($self->{"handle"}, @_) if($self->{"handle"}) or die "invalid handle";
	1;
}

sub _init
{
	my $self = shift;
	my $handle = shift || nConstruct();
	my %param = @_;
	$param{"handle"} = $handle;
	%{$self} = %param;
}

sub DESTROY
{
	my $self = shift;
	nDestruct($self->{"handle"}) if $self->{"handle"};
}


# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__
# Below is the stub of documentation for your module. You better edit it!

=head1 NAME

soplex::saferpay::MessageObject - Perl extension for the Saferpay Application Component.

=head1 SYNOPSIS

  refer to the soplex::saferpay::MessageFactory documentation;

=head1 DESCRIPTION

refer to http://www.saferpay.com/help/ for a complete description of the Saferpay Application Component.

=head1 AUTHOR

Soplex AG, support@saferpay.com

=head1 SEE ALSO

perl(1), perlxs(1), soplex::saferpay::MessageFactory(1).

=cut
