####### Compiler, tools and options
CC	=	gcc
CXX	=	g++

CFLAGS	=	-pipe -fPIC -O2
CXXFLAGS=	-pipe -fPIC -O2
INCPATH	=		

LINK	=	g++
LFLAGS	=	-fPIC -ldl
LIBS	=	-lidpapp
MOC	=	$(QTDIR)/bin/moc

TAR	=	tar -cf
GZIP	=	gzip -9f

####### Files

HEADERS =	idpapi.h \
		idperrc.h
SOURCES =	saferpay.c
OBJECTS =	saferpay.o
SRCMOC	=	
OBJMOC	=	
DIST	=	
TARGET	=	./out/saferpay

####### Implicit rules

.SUFFIXES: .cpp .cxx .cc .C .c

.cpp.o:
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o $@ $<

.cxx.o:
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o $@ $<

.cc.o:
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o $@ $<

.C.o:
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o $@ $<

.c.o:
	$(CC) -c $(CFLAGS) $(INCPATH) -o $@ $<

####### Build rules

all: $(TARGET)

$(TARGET): $(OBJECTS) $(OBJMOC) 
	$(LINK) $(LFLAGS) -o $(TARGET) $(OBJECTS) $(OBJMOC) $(LIBS)

moc: $(SRCMOC)

tmake: saferpay.mk

# no more tmake


dist:
	$(TAR) saferpay.tar saferpay.pro $(SOURCES) $(HEADERS) $(DIST)
	$(GZIP) saferpay.tar

clean:
	-rm -f $(OBJECTS) $(OBJMOC) $(SRCMOC) $(TARGET)
	-rm -f *~ core

####### Compile

saferpay.o: saferpay.c \
		idpapi.h \
		idperrc.h

