// sxexcept.h: definition of the SXFC exception class

#ifndef __SXFCEXCEPT_H__
#define __SXFCEXCEPT_H__

#include "sxtchar.h"

#define MAX_ERROR_MESSAGE 255

class SXFC_Exception
{
public:
	SXFC_Exception()
	{
		m_szDetail[0] = 0;
		m_code = 0L;
	}

	SXFC_Exception(HRESULT code)
	{
		m_szDetail[0] = 0;
		m_code = code;
	}

	SXFC_Exception(HRESULT code, const TCHAR *pszMsg)
	{
		m_code = code;
		TSPRINTF(m_szDetail, pszMsg);
	}

	const TCHAR *getMessage()
	{
		TSPRINTF(m_szMsg, _T("Error: 0x%08x "), m_code);
		if(m_szDetail[0])
		{
			SX_SIZE_T len = TCSLEN(m_szMsg);
			TSPRINTF(&m_szMsg[len], _T("; %s"), m_szDetail);
		}
		return m_szMsg;
	}

private:
	HRESULT m_code;
	TCHAR m_szDetail[MAX_ERROR_MESSAGE];
	TCHAR m_szMsg[MAX_ERROR_MESSAGE + 25];
};


#endif // __SXFCEXCEPT_H__
