// sxlist.h: SXFC linked list

#ifndef __SXLIST_H__
#define __SXLIST_H__

#include "sxobject.h"

class SxListItem
{
public:
	SxListItem() : m_pPrevious(0), m_pNext(0), m_pObj(0) {;}
	SxListItem(SxObject *pObj, SxListItem *pPrevious = 0)
		: m_pNext(0), m_pPrevious(pPrevious)
	{
		if(pPrevious)
			pPrevious->m_pNext = this;

		m_pObj = pObj;
	}

	virtual ~SxListItem()
	{
		if(m_pPrevious)
		{
			m_pPrevious->m_pNext = m_pNext;

			if(m_pNext)
				m_pNext->m_pPrevious = m_pPrevious;
		}
		else if(m_pNext)
				m_pNext->m_pPrevious = 0;
	}

	SxListItem *m_pPrevious, *m_pNext;
	SxObject *m_pObj;
};

#endif // __SXLIST_H__
