// sxpair.cpp: implementation of SXFC key/value pair class

#include "sxfcerr.h"
#include "sxexcept.h"
#include "sxpair.h"



// operators

// SxFindable
bool SxKeyValue::operator <(const SxFindable& obj) const
{
	if(obj.isInstanceOf(_T("SxKeyValue")))
		return (*m_pKey < ((SxKeyValue&)obj).first());
	else
		return (*m_pKey < obj);
}

bool SxKeyValue::operator ==(const SxFindable& obj) const
{
	if(obj.isInstanceOf(_T("SxKeyValue")))
		return (*m_pKey == ((SxKeyValue&)obj).first());
	else
		return (*m_pKey == obj);
}


// public methods

// SxObject
SxObject& SxKeyValue::assign(const SxObject& obj) // throws SXFC_Exception
{
	if(!!m_pValue)
	{
		delete m_pValue;
		m_pValue = 0;
	}

	if(obj.isInstanceOf(_T("SxKeyValue")))
	{
		if(!!m_pKey)
		{
			delete m_pKey;
			m_pKey = 0;
		}

		Allocator pfnAllocate = ((SxKeyValue&)obj).second().getAllocator();
		pfnAllocate(&m_pValue);
		pfnAllocate = ((SxKeyValue&)obj).first().getAllocator();
		pfnAllocate((SxObject**)(&m_pKey));

		m_pValue->assign(((SxKeyValue&)obj).second());
		m_pKey->assign(((SxKeyValue&)obj).first());

		return *this;
	}
	else
	{
		Allocator pfnAllocate = obj.getAllocator();
		pfnAllocate(&m_pValue);

		return m_pValue->assign(obj);
	}
}

