// sxstack.h: SXFC object pointer stack

#ifndef __SXSTACK_H__
#define __SXSTACK_H__

#include "sxvector.h"
#include "sxexcept.h"
#include "sxfcerr.h"

class SxStack : public SxVector
{
public:
	SxStack() : SxVector()
	{
		;
	}

	SxStack(SX_SIZE_T initialCapacity) : SxVector(initialCapacity)
	{
		;
	}

	// SxObject
	ALLOC_IMPL(SxStack);
	virtual bool isInstanceOf(const TCHAR *pszClass) const
	{
		if(!TCSCMP(pszClass, _T("SxStack")))
			return true;

		return SxVector::isInstanceOf(pszClass);
	}

	void push(SxObject* pObj)
	{
		push_back(pObj);
	}

	SxObject *peek()
	{
		if(!m_size)
		{
			throw SXFC_Exception(E_SXFC_OUT_OF_BOUND);
			return 0;
		}

		return at(m_size - 1);
	}

	SxObject* pop()
	{
		SxObject *pRet = peek();
		pop_back();
		return pRet;
	}
};


#endif // __SXSTACK_H__
