// sxstream.h: SXFC implementation for stringstreams

#ifndef __SXSTREAM_H__
#define __SXSTREAM_H__

#include "sxstring.h"

class SxStringStream
{
public:
	SxStringStream()
	{
		m_pos = 0;
		m_bad = true;
	}
	SxStringStream(SxStringStream& s)
	{
		m_s = s.str();
		m_pos = s.m_pos;
		m_bad = false;
	}


	SxStringStream& operator << (const TCHAR *psz)
	{
		m_s += psz;
		m_bad = false;
		return (*this);
	}
	SxStringStream& operator << (const TCHAR c)
	{
		m_s += c;
		m_bad = false;
		return (*this);
	}
	SxStringStream& operator << (const SxString& s)
	{
		m_s += s;
		m_bad = false;
		return (*this);
	}
	SxStringStream& operator << (long n)
	{
		TCHAR buf[32];
		TSPRINTF(buf, _T("%ld"), n);
		m_s += buf;
		return (*this);
	}
	SxStringStream& operator << (int n)
	{
		TCHAR buf[32];
		TSPRINTF(buf, _T("%d"), n);
		m_s += buf;
		return (*this);
	}

	SxStringStream& get(TCHAR& c)
	{
		if(m_pos < m_s.size())
		{
			c = m_s.c_str()[m_pos];
			m_pos++;
		}

		else
		{
			m_bad = true;
		}

		return (*this);
	}
	bool good()
	{
		return (!m_bad);
	}
	bool eof()
	{
		return m_bad;
	}
	SxStringStream& putback(TCHAR& c)
	{
		if(m_pos > 0)
		{
			c = m_s.c_str()[m_pos];
			m_pos--;
			m_bad = false;
		}
	
		else
			m_pos = 0;

		return (*this);
	}

	SxString& str()
	{
		return m_s;
	}

protected:
	SxString m_s;
	SX_SIZE_T m_pos;
	bool m_bad;
};

#endif // __SXSTREAM_H__
