// sxtchar.cpp: simple tchar routines

#include "sxtchar.h"

SX_SIZE_T TCSLEN(const TCHAR *psz)
{
	const TCHAR *p = psz;
	SX_SIZE_T len = 0L;

	if(p)
	{
		while(*p++)
			len++;
	}

	return len;
}

TCHAR *TCSCPY(TCHAR *psz1, const TCHAR *psz2)
{
	TCHAR *pszOld = psz1;

	while((*psz1++ = *psz2++));
	return pszOld;
}

TCHAR *TCSNCPY(TCHAR *psz1, const TCHAR *psz2, SX_SIZE_T len)
{
	TCHAR *pszOld = psz1;

	while((*psz1++ = *psz2++) && len--);
	return pszOld;
}

int TCSNCMP(const TCHAR *psz1, const TCHAR *psz2, SX_SIZE_T len)
{
	if(!psz1)
		return psz2 ? -1 : 0;

	if(!psz2)
		return 1;

	while(len == -1 ? 1 : len--)
	{
		if(!(*psz1))
			return *psz2 ? -1 : 0;

		if(!(*psz2))
			return 1;

		if(*psz1 > *psz2)
			return 1;

		if(*psz2 > *psz1)
			return -1;

		psz1++;
		psz2++;
	}

	return 0;
}
