// sxtchar.h: definition of type TCHAR

#ifndef __SXTCHAR_H__
#define __SXTCHAR_H__



#include <stdio.h>
#include "sxfctype.h"

#ifdef _UNICODE
#ifndef UNICODE
#define UNICODE
#endif
#endif

#ifdef UNICODE
#ifndef _TCHAR_DEFINED
#define _TCHAR_DEFINED
typedef unsigned short TCHAR;
#endif
#ifndef _T
#define _T(x) L##x
#endif

#else
#ifndef _TCHAR_DEFINED
#define _TCHAR_DEFINED
typedef char TCHAR;
#endif
#ifndef _T
#define _T(x) x
#endif
#endif // UNICODE


#ifdef __cplusplus
extern "C" {
#endif

SX_SIZE_T TCSLEN(const TCHAR *psz);
TCHAR *TCSCPY(TCHAR*, const TCHAR*);
TCHAR *TCSNCPY(TCHAR*, const TCHAR*, SX_SIZE_T len);
int TCSNCMP(const TCHAR *psz1, const TCHAR *psz2, SX_SIZE_T len);
#define TCSCMP(psz1, psz2) TCSNCMP(psz1, psz2, (SX_SIZE_T)-1)

#ifdef __cplusplus
}
#endif


#ifdef UNICODE
#define TSPRINTF swprintf
#else
#define TSPRINTF sprintf
#endif


#endif // __SXTCHAR_H__

