// xmlElementEnum.cpp

#include "xmlcore.h"
#include "xmlElement.h"
#include "xmlElementEnum.h"

void xmlElementEnum::create(xmlElement * pElement, 
							const SxString & strTag)
{
	// hold element in memory
	m_pElement = pElement;

	// start at the beginning
	if(!strTag.empty())
	{
		SxFindableVector *pVec = (SxFindableVector*)m_pElement->m_children.find(strTag);
		if(pVec)
		{
			m_begin = (SxMapItem*)pVec->begin();
			m_end = (SxMapItem*)pVec->end();
		}
		else
		{
			m_begin = 0;
			m_end = 0;
		}
	}
	else
	{
		m_begin = m_pElement->m_children.begin();
		m_end = m_pElement->m_children.end();
	}

	m_it = m_begin;
}

bool xmlElementEnum::getNext(xmlElement ** ppElement)
{
	if(m_it != m_end)
	{
		element_ptr tmp = (element_ptr&)m_it->second();
		* ppElement = tmp.Detach();
		++ m_it;
		return true;
	}
	else
	{
		return false;
	}
}

bool xmlElementEnum::isEmpty()
{
	return (m_it == m_end);
}


