// xmlElementEnum.h

#ifndef __XMLELEMENTENUM_H__
#define __XMLELEMENTENUM_H__

class xmlElementEnum;
class xmlEnumPtr;

#include "xmlcore.h"
#include "xmlElement.h"

class xmlElementEnum : public SxObject
{
	friend class xmlElement;

public:
	xmlElementEnum() : SxObject() {;}

	// SxObject
	ALLOC_IMPL(xmlElementEnum);
	virtual bool isInstanceOf(const TCHAR *pszClass) const
	{
		if(!TCSCMP(pszClass, _T("xmlElementEnum")))
			return true;

		return SxObject::isInstanceOf(pszClass);
	}

private:
	typedef class xmlElementPtr element_ptr;
	typedef class SxStrObjMultimap element_map;
	typedef class xmlEnumPtr enum_ptr;

	element_ptr m_pElement;
	element_map::iterator m_begin, m_end, m_it;
	long m_index;

private:
	void create(xmlElement * pElement, const SxString & strTag); 

public:
	bool getNext(xmlElement ** ppElement);
	bool isEmpty();
};

// SxPtr<xmlElementEnum>
class xmlEnumPtr : public SxPtr
{
protected:
	xmlElementEnum *p;

public:
	xmlEnumPtr() { p = 0; }
	xmlEnumPtr(xmlElementEnum * _p) { p = _p; if(p) p->AddRef(); }
	xmlEnumPtr(const xmlEnumPtr& a) { p = a.p; if(p) p->AddRef(); }

	// SxObject
	ALLOC_IMPL(xmlEnumPtr);
	virtual bool isInstanceOf(const TCHAR *pszClass) const
	{
		if(!TCSCMP(pszClass, _T("xmlEnumPtr")))
			return true;

		return SxPtr::isInstanceOf(pszClass);
	}

	void operator = (xmlElementEnum *_p) { if(p) p->Release(); p = _p; if(p) p->AddRef(); }
	void operator = (const xmlEnumPtr& eop) { if(p) p->Release(); p = eop.p; if(p) p->AddRef(); }
	inline operator xmlElementEnum * () { return p; }

	// pointer comparison
	//bool operator == (const T * _p) const { return (p == _p); }

	// the invocation operator
	inline xmlElementEnum * operator->() { _ASSERT(p != NULL); return p; }
	inline const xmlElementEnum * operator->() const { _ASSERT(p != NULL); return p; }

	// the & operator is not used because of conflicts with STL
	inline xmlElementEnum ** Ptr() { _ASSERT(p == NULL); return & p; }

	// return without calling release
	inline xmlElementEnum * Detach() { xmlElementEnum * t = p; p = 0; return t; }
};



#endif
