// xmltab.h

#ifndef __XMLTAB_H__
#define __XMLTAB_H__

#include "../sxfc/sxtchar.h"

#ifdef __cplusplus
extern "C" 
{
#endif

enum Symbols
{
	s_space				=	1, 
	s_tag_open			=	2, 
	s_alnum				=	4, 
	s_equal				=	8, 
	s_squote			= 0x10, 
	s_dquote			= 0x20, 
	s_tag_end			= 0x40, 
	s_tag_close			= 0x80,
	s_other				= 0x100,
	s_all				= 0xfff
};

enum Actions 
{
	a_nop = 0,
	a_error,			// invalid state transition
	a_append,			// the current c is appended to token
	a_keep,				// do'nt clear buffer
	a_clear,			// clear the token buffer
	a_create_tag,		// a new element is created with tag name
	a_create_attr,		// an attribute is set, save token
	a_close_tag,		// the element is popped from the stack
	a_attr_value,		// an attribute value is set
	a_text
};

typedef struct _tabEntry
{
	// ordering by state, symbol makes bsearch possible
	int state, symbol, advance, next, action;
}
tabEntry;

extern tabEntry xmlTable[];

const tabEntry * getTabEntry(const tabEntry * table, int N, int s, TCHAR c);

#ifdef __cplusplus
}
#endif

#endif




